Public MustInherit Class GattThreadMessage
    Inherits wclMessage

    Public Const MSG_CAT_GATT_THREAD = wclMessage.WCL_MSG_CATEGORY_USER + 1

    Public Const MSG_ID_GATT_THREAD_BASE = 1
    Public Const MSG_ID_GATT_THREAD_CONNECTED = MSG_ID_GATT_THREAD_BASE + 1
    Public Const MSG_ID_GATT_THREAD_DISCONNECTED = MSG_ID_GATT_THREAD_BASE + 2
    Public Const MSG_ID_GATT_THREAD_VALUE_CHANGED = MSG_ID_GATT_THREAD_BASE + 3
    Public Const MSG_ID_GATT_THREAD_WRITE_COMPLETED = MSG_ID_GATT_THREAD_BASE + 4

    Public Sub New(ByVal Id As Byte)
        MyBase.New(Id, MSG_CAT_GATT_THREAD)
    End Sub
End Class

Public Class GattThreadConnectedMessage
    Inherits GattThreadMessage

    Private FError As Integer

    Public Sub New(ByVal [Error] As Integer)
        MyBase.New(MSG_ID_GATT_THREAD_CONNECTED)

        FError = [Error]
    End Sub

    Public ReadOnly Property [Error]() As Integer
        Get
            Return FError
        End Get
    End Property
End Class

Public Class GattThreadDisconnectedMessage
    Inherits GattThreadMessage

    Private FReason As Integer

    Public Sub New(ByVal Reason As Integer)
        MyBase.New(MSG_ID_GATT_THREAD_DISCONNECTED)

        FReason = Reason
    End Sub

    Public ReadOnly Property Reason() As Integer
        Get
            Return FReason
        End Get
    End Property
End Class

Public Class GattThreadValueChangedMessage
    Inherits GattThreadMessage

    Private FHandle As UInt16
    Private FValue As Byte()

    Public Sub New(ByVal Handle As UInt16, ByVal Value As Byte())
        MyBase.New(MSG_ID_GATT_THREAD_VALUE_CHANGED)

        FHandle = Handle
        FValue = Value
    End Sub

    Public ReadOnly Property Handle() As UInt16
        Get
            Return FHandle
        End Get
    End Property

    Public ReadOnly Property Value() As Byte()
        Get
            Return FValue
        End Get
    End Property
End Class

Public Class GattThreadWriteCompletedMessage
    Inherits GattThreadMessage

    Private FResult As Integer

    Public Sub New(ByVal Result As Integer)
        MyBase.New(MSG_ID_GATT_THREAD_WRITE_COMPLETED)

        FResult = Reset()

    End Sub

    Public ReadOnly Property Result() As Integer
        Get
            Return FResult
        End Get
    End Property
End Class